import java.applet.*;
import java.awt.*;
import java.net.*;
import java.io.*;



class Carte
{
    static final int ECHELLE = 20;
    private boolean[][] mur;
    private boolean[][] position;
    private Caisse[][] lesCaisses;
    private int dimensionX = 0, dimensionY=0;

    

    private String readFile(String filename) {	
	StringBuffer buf = new StringBuffer();
	String l;
	try {
	    BufferedReader breader = new BufferedReader(new FileReader(filename));
	    while (breader.ready()) 
		{
		    l = breader.readLine();
		    if (l.length() > dimensionX) dimensionX = l.length();
		    buf.append(l + "\n");
		    dimensionY++;		    
		}
	    breader.close();
	} catch (Exception e) {
	    System.out.println("erreur dans readFile");
	}
	return buf.substring(0,buf.length()-1);
    }
    

    private String readUrl(String filename, URL doc) {
	URL u;
	BufferedReader dis;
	String l;
	StringBuffer buf = new StringBuffer();
	
	try
	    {
		u = new URL(doc, filename);
		
		// Lire le flux d'entre li au fichier
		dis = new BufferedReader(new InputStreamReader(u.openStream()));	
		// Lire le fichier jusqu' la fin
		while ((l = dis.readLine())!= null)
		    {
			if (l.length() > dimensionX) dimensionX = l.length();
			buf.append(l + "\n");
			dimensionY++;
		    }
		
	    } catch(Exception e) {}
	return buf.substring(0,buf.length()-1);
    }
    
    

    Carte(String fichier, URL url)
    {
	int x = 0, y = 0;
	
	String ligne;
	if (url == null)
	    ligne = readFile(fichier);
	else ligne = readUrl(fichier, url);
	
	mur = new boolean[dimensionX][dimensionY];
	position = new boolean[dimensionX][dimensionY];
	lesCaisses = new Caisse[dimensionX][dimensionY];

	for(int i = 0 ; i < ligne.length(); i++)
	    {
		switch(ligne.charAt(i))
		    {
		    case '.' :
			position[x][y] = true;
			break;
		    case 'X' :
			mur[x][y] = true;
			break;
		    case '\n' :
			x = -1;
			y++;
			break;
		    }
		x++;
	    }
    }
    

    public void retireCaisse(int x, int y)
    {
	lesCaisses[x][y] = null;
    }
    
    public void placeCaisse(int x, int y, Caisse c)
    {	
	lesCaisses[x][y] = c;
    }

    public boolean mur(int x, int y)
    {
	return mur[x][y];
    }

    public boolean position(int x, int y)
    {
	return position[x][y];
    }
    
    public Caisse caisse(int x, int y)
    {
	return lesCaisses[x][y];
    }

    public void paint(Graphics g)
    {
	int x, y;
	for (y = 0; y < dimensionY; y++) {
	    for (x = 0; x < dimensionX; x++) {
		if (mur[x][y])  {
		    g.setColor(Color.gray);	
		    g.fillRect(x*ECHELLE, y*ECHELLE, ECHELLE,ECHELLE);
		} else if (position[x][y]) {
		    g.setColor(Color.blue);
		    g.fillOval(x*ECHELLE +6, y*ECHELLE+6, 8,8);
		}
	    }
	}
    }
}
